
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "sdb.h"

char *url;

/* A callback for queries where we don't expect anything interesting */
int db_null(int n, char **p, void *closure)
{
        return 0;
}      

/* A callback for queries which return a single integer */
int db_counter(int n, char **p, void *closure)
{
        int *i = (int *)closure;

        *i = atoi(p[0]);
        return 0;
}

/* returns the last used value with the given name */
int get_counter(char *name)
{
        char b[4096];
        int value = 0;
        snprintf(b, sizeof b,
                "select value from counters where name='%s'", name);
        sdb_query(url, b, db_counter, (void *)&value);
        return value;
}

/* stores a value with the given name */
void put_counter(char *name, int value)
{
        char b[4096];
        snprintf(b, sizeof b, "delete from counters where name='%s'", name);
        sdb_query(url, b, db_null, NULL);
        snprintf(b, sizeof b,
                "insert into counters (name, value) "
                "values ('%s', %d)",
                name, value);
        sdb_query(url, b, db_null, NULL);
}

/* returns the lowest unused value and stores it back */
int counter(char *name)
{
        int value = get_counter(name)+1;
        put_counter(name, value);
        return value;
}

void blacklist(char *p, char *bl, int r)
{
	char *q = p;
	while (*p) {
		if (!strchr(bl, *p)) {
			*q++ = *p;
		} else if (r) {
			*q++ = r;
		}
		p++;
	}
	*q = '\0';
}

void whitelist(char *p, char *wl, int r)
{
	char *q = p;
	while (*p) {
		if (strchr(wl, *p)) {
			*q++ = *p;
		} else if (r) {
			*q++ = r;
		}
		p++;
	}
	*q = '\0';
}

void upcase(char *p)
{
	while (*p) {
		*p = toupper(*p);
		p++;
	}
}

int cstrcasecmp(const char *p, const char *q)
{
	int c;

	while (!(c = toupper(*p)-toupper(*q)) && *p) {
		p++;
		q++;
	}
	return c;
}

int cstrncasecmp(const char *p, const char *q, size_t n)
{
	size_t i = 0;
	int c = 0;

	while ((i < n) && !(c = toupper(*p)-toupper(*q)) && *p) {
		p++;
		q++;
		i++;
	}
	return c;
}

static void alloc_fail(void)
{
	fprintf(stderr, "Memory allocation failure\n");
	exit(EXIT_FAILURE);
}

char *cstrdup(const char *s)
{
	char *p;

	if (s) p = malloc(strlen(s)+1);
	else p = NULL;
	if (p == NULL) alloc_fail();
	else strcpy(p, s);
	return p;
}

void *cmalloc(size_t size)
{
	void *p;

	p = malloc(size);
	if (p == NULL) alloc_fail();
	return p;
}

void cfree(void *p)
{
	free(p);
}

void chomp(char *p)
{
	if ((p = strchr(p, '\n'))) *p = '\0';
}

